// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009-2011, Alan Calvert

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is derivative of ZynAddSubFX original code, modified March 2011

// generated by Fast Light User Interface Designer (fluid) version 1.0302

#include "/home/iurt/rpmbuild/BUILD/yoshimi-0.060.12/src/build/ConfigUI.h"

void ConfigUI::cb_configwindow_i(Fl_Double_Window* o, void*) {
  //
          if (configChanged)
          {
              int r = fl_choice("Save settings?", "Cancel", "Save", "Don't save");
              switch (r)
              {
                  case 1:
                      o->hide();
                      savesettings();
                      break;
                  case 2:
                      o->hide();
                      break;
                  default:
                      break;
              }
          }
          else
              o->hide();
}
void ConfigUI::cb_configwindow(Fl_Double_Window* o, void* v) {
  ((ConfigUI*)(o->user_data()))->cb_configwindow_i(o,v);
}

void ConfigUI::cb_OscilSize_i(Fl_Choice* o, void*) {
  //
                Runtime.Oscilsize = 128 << o->value();
                configChanged = true;
}
void ConfigUI::cb_OscilSize(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_OscilSize_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_OscilSize[] = {
 {"128", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"256", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"512", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"1024", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"2048", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"4096", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"8192", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"16384", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_PADsynth_i(Fl_Choice* o, void*) {
  //
                Runtime.Interpolation = (int) o->value();
                configChanged = true;
}
void ConfigUI::cb_PADsynth(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_PADsynth_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_PADsynth[] = {
 {"Linear(fast)", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Cubic(slow)", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_Virtual_i(Fl_Choice* o, void*) {
  //
                Runtime.VirKeybLayout = (int) o->value();
                configChanged = true;
}
void ConfigUI::cb_Virtual(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Virtual_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_Virtual[] = {
 {" ", 0,  0, 0, 1, FL_NORMAL_LABEL, 1, 11, 0},
 {"QWERTY", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 11, 0},
 {"Dvorak", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 11, 0},
 {"QWERTZ", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 11, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_SessionStateFile_i(Fl_Input* o, void*) {
  //
              Runtime.StateFile = string(o->value());
              SessionStateFile->changed();
}
void ConfigUI::cb_SessionStateFile(Fl_Input* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_SessionStateFile_i(o,v);
}

void ConfigUI::cb_StateFileButton_i(Fl_Button*, void*) {
  //
                const char *filename = fl_file_chooser("Nominate session save state file",
                                                       NULL, Runtime.StateFile.c_str(), 0);
                if (NULL != filename)
                {
                    Runtime.StateFile = string(filename);
                    SessionStateFile->value(Runtime.StateFile.c_str());
                    SessionStateFile->changed();
                    configChanged = true;
                };
}
void ConfigUI::cb_StateFileButton(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_StateFileButton_i(o,v);
}

void ConfigUI::cb_rootsbrowse_i(Fl_Browser* o, void*) {
  activatebutton_rootdir(o->value()!=0);
}
void ConfigUI::cb_rootsbrowse(Fl_Browser* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_rootsbrowse_i(o,v);
}

void ConfigUI::cb_Add_i(Fl_Button*, void*) {
  //
                const char *dirname;
                dirname = fl_dir_chooser("Add a root directory for banks:", NULL, 0);
                if (!dirname)
                    return;
                rootsbrowse->add(dirname);
                configChanged = true;
}
void ConfigUI::cb_Add(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Add_i(o,v);
}

void ConfigUI::cb_removerootdirbutton_i(Fl_Button*, void*) {
  //
                if (rootsbrowse->value() != 0)
                    rootsbrowse->remove(rootsbrowse->value());
                activatebutton_rootdir(false);
                configChanged = true;
}
void ConfigUI::cb_removerootdirbutton(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_removerootdirbutton_i(o,v);
}

void ConfigUI::cb_makedefaultrootdirbutton_i(Fl_Button*, void*) {
  //
                int n = rootsbrowse->value();
                if (n != 0)
                {
                    rootsbrowse->move(1, n);
                    rootsbrowse->value(1);
                    rootsbrowse->redraw();
                }
                activatebutton_rootdir(true);
                configChanged = true;
}
void ConfigUI::cb_makedefaultrootdirbutton(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_makedefaultrootdirbutton_i(o,v);
}

void ConfigUI::cb_presetbrowse_i(Fl_Browser* o, void*) {
  activatebutton_presetdir(o->value() != 0);
}
void ConfigUI::cb_presetbrowse(Fl_Browser* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_presetbrowse_i(o,v);
}

void ConfigUI::cb_Add1_i(Fl_Button*, void*) {
  //
                const char *dirname;
                dirname = fl_dir_chooser("Add a preset directory :", NULL, 0);
                if (!dirname)
                    return;
                presetbrowse->add(dirname);
                configChanged = true;
}
void ConfigUI::cb_Add1(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Add1_i(o,v);
}

void ConfigUI::cb_removepresetbutton_i(Fl_Button*, void*) {
  //
                if (presetbrowse->value() != 0)
                {
                    presetbrowse->remove(presetbrowse->value());
                }
                activatebutton_presetdir(false);
                configChanged = true;
}
void ConfigUI::cb_removepresetbutton(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_removepresetbutton_i(o,v);
}

void ConfigUI::cb_makedefaultpresetbutton_i(Fl_Button*, void*) {
  //
                int n = presetbrowse->value();
                if (n != 0)
                {
                    presetbrowse->move(1, n);
                    presetbrowse->value(1);
                    presetbrowse->redraw();
                }
                activatebutton_presetdir(true);
                configChanged = true;
}
void ConfigUI::cb_makedefaultpresetbutton(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_makedefaultpresetbutton_i(o,v);
}

void ConfigUI::cb_Jack_i(Fl_Input* o, void*) {
  //
                Runtime.jackServer = string(o->value());
                configChanged = true;
}
void ConfigUI::cb_Jack(Fl_Input* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Jack_i(o,v);
}

void ConfigUI::cb_Alsa_i(Fl_Input* o, void*) {
  //
                Runtime.alsaMidiDevice = string(o->value());
                configChanged = true;
}
void ConfigUI::cb_Alsa(Fl_Input* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Alsa_i(o,v);
}

void ConfigUI::cb_Alsa1_i(Fl_Input* o, void*) {
  //
                Runtime.alsaAudioDevice = string(o->value());
                configChanged = true;
}
void ConfigUI::cb_Alsa1(Fl_Input* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Alsa1_i(o,v);
}

void ConfigUI::cb_Samplerate_i(Fl_Check_Browser* o, void*) {
  //
                int chk = o->value();
                if (o->nchecked() < 1)
                    o->set_checked(chk = 2);
                else if (o->nchecked() > 1)
                {
                    if (!chk)
                        chk = 2;
                    o->check_none();
                    o->set_checked(chk);
                }
                unsigned int sample_rate;
                switch (chk)
                {
                    case 1:
                        sample_rate = 96000;
                        break;
                    case 3:
                        sample_rate = 44100;
                        break;
                    case 2:
                    default:
                        sample_rate = 48000;
                        break;
                }
                Runtime.Samplerate = sample_rate;
                configChanged = true;
}
void ConfigUI::cb_Samplerate(Fl_Check_Browser* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Samplerate_i(o,v);
}

void ConfigUI::cb_Period_i(Fl_Check_Browser* o, void*) {
  //
                int chk = o->value();
                if (o->nchecked() < 1)
                    o->set_checked(4);
                else if (o->nchecked() > 1)
                {
                    if (!chk)
                        chk = 3;
                    o->check_none();
                    o->set_checked(chk);
                }
                int buff_size;
                switch (chk)
                {
                    case 1: buff_size = 64; break;
                    case 2: buff_size = 128; break;
                    case 3: buff_size = 256; break;
                    case 4: buff_size = 512; break;
                    case 5: buff_size = 1024; break;
                    default: buff_size = 512; break;
                }
                Runtime.Buffersize = buff_size;
                configChanged = true;
}
void ConfigUI::cb_Period(Fl_Check_Browser* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Period_i(o,v);
}

void ConfigUI::cb_Close_i(Fl_Button*, void*) {
  configwindow->do_callback();
}
void ConfigUI::cb_Close(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_Close_i(o,v);
}

void ConfigUI::cb_Save_i(Fl_Button*, void*) {
  savesettings();
}
void ConfigUI::cb_Save(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_Save_i(o,v);
}

Fl_Double_Window* ConfigUI::make_window() {
  { configwindow = new Fl_Double_Window(465, 335, "Yoshimi Settings");
    configwindow->callback((Fl_Callback*)cb_configwindow, (void*)(this));
    { Fl_Tabs* o = new Fl_Tabs(5, 5, 520, 325);
      { Fl_Group* o = new Fl_Group(5, 25, 460, 260, "Main settings");
        o->labelsize(12);
        o->hide();
        { Fl_Choice* o = new Fl_Choice(196, 52, 100, 20, "OscilSize");
          o->tooltip("ADSynth Oscillator Size (samples)");
          o->down_box(FL_BORDER_BOX);
          o->labelsize(12);
          o->textsize(11);
          o->callback((Fl_Callback*)cb_OscilSize);
          o->menu(menu_OscilSize);
          o->value( (int)(logf(Runtime.Oscilsize / 128.0f - 1.0f) / logf(2.0f)) + 1);
        } // Fl_Choice* o
        { Fl_Choice* o = new Fl_Choice(255, 162, 100, 20, "PADsynth Interpolation");
          o->down_box(FL_BORDER_BOX);
          o->labelsize(12);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_PADsynth);
          o->menu(menu_PADsynth);
          o->value(Runtime.Interpolation);
        } // Fl_Choice* o
        { Fl_Choice* o = new Fl_Choice(255, 108, 100, 20, "Virtual Keyboard Layout");
          o->down_box(FL_BORDER_BOX);
          o->labelsize(12);
          o->textfont(1);
          o->textsize(13);
          o->callback((Fl_Callback*)cb_Virtual);
          o->menu(menu_Virtual);
          o->value(Runtime.VirKeybLayout);
        } // Fl_Choice* o
        { Fl_Input* o = SessionStateFile = new Fl_Input(159, 216, 235, 25, "Session state save file");
          SessionStateFile->labelsize(12);
          SessionStateFile->textsize(12);
          SessionStateFile->callback((Fl_Callback*)cb_SessionStateFile);
          SessionStateFile->when(FL_WHEN_CHANGED);
          o->value(Runtime.StateFile.c_str());
        } // Fl_Input* SessionStateFile
        { StateFileButton = new Fl_Button(404, 218, 49, 20, "Select");
          StateFileButton->labelsize(12);
          StateFileButton->callback((Fl_Callback*)cb_StateFileButton);
          /* code */
        } // Fl_Button* StateFileButton
        o->end();
      } // Fl_Group* o
      { Fl_Group* o = new Fl_Group(5, 25, 460, 287, "Bank root dirs");
        o->labelsize(12);
        o->hide();
        { rootsbrowse = new Fl_Browser(15, 35, 485, 200);
          rootsbrowse->type(2);
          rootsbrowse->labelsize(12);
          rootsbrowse->textsize(13);
          rootsbrowse->callback((Fl_Callback*)cb_rootsbrowse);
        } // Fl_Browser* rootsbrowse
        { Fl_Button* o = new Fl_Button(15, 244, 80, 35, "Add root directory...");
          o->box(FL_THIN_UP_BOX);
          o->labelsize(12);
          o->callback((Fl_Callback*)cb_Add);
          o->align(Fl_Align(FL_ALIGN_WRAP));
        } // Fl_Button* o
        { Fl_Button* o = removerootdirbutton = new Fl_Button(105, 244, 80, 35, "Remove root dir...");
          removerootdirbutton->box(FL_THIN_UP_BOX);
          removerootdirbutton->labelsize(12);
          removerootdirbutton->callback((Fl_Callback*)cb_removerootdirbutton);
          removerootdirbutton->align(Fl_Align(FL_ALIGN_WRAP));
          o->deactivate();
        } // Fl_Button* removerootdirbutton
        { Fl_Button* o = makedefaultrootdirbutton = new Fl_Button(190, 244, 80, 35, "Make default");
          makedefaultrootdirbutton->box(FL_THIN_UP_BOX);
          makedefaultrootdirbutton->labelsize(12);
          makedefaultrootdirbutton->callback((Fl_Callback*)cb_makedefaultrootdirbutton);
          makedefaultrootdirbutton->align(Fl_Align(FL_ALIGN_WRAP));
          o->deactivate();
        } // Fl_Button* makedefaultrootdirbutton
        o->end();
      } // Fl_Group* o
      { Fl_Group* o = new Fl_Group(5, 25, 460, 260, "Presets dirs");
        o->labelsize(12);
        o->hide();
        { presetbrowse = new Fl_Browser(15, 35, 485, 200);
          presetbrowse->type(2);
          presetbrowse->labelsize(12);
          presetbrowse->textsize(12);
          presetbrowse->callback((Fl_Callback*)cb_presetbrowse);
        } // Fl_Browser* presetbrowse
        { Fl_Button* o = new Fl_Button(15, 244, 80, 35, "Add preset directory...");
          o->box(FL_THIN_UP_BOX);
          o->labelsize(12);
          o->callback((Fl_Callback*)cb_Add1);
          o->align(Fl_Align(FL_ALIGN_WRAP));
        } // Fl_Button* o
        { Fl_Button* o = removepresetbutton = new Fl_Button(105, 244, 80, 35, "Remove preset dir...");
          removepresetbutton->box(FL_THIN_UP_BOX);
          removepresetbutton->labelsize(12);
          removepresetbutton->callback((Fl_Callback*)cb_removepresetbutton);
          removepresetbutton->align(Fl_Align(FL_ALIGN_WRAP));
          o->deactivate();
        } // Fl_Button* removepresetbutton
        { Fl_Button* o = makedefaultpresetbutton = new Fl_Button(190, 244, 80, 35, "Make default");
          makedefaultpresetbutton->box(FL_THIN_UP_BOX);
          makedefaultpresetbutton->labelsize(12);
          makedefaultpresetbutton->callback((Fl_Callback*)cb_makedefaultpresetbutton);
          makedefaultpresetbutton->align(Fl_Align(FL_ALIGN_WRAP));
          o->deactivate();
        } // Fl_Button* makedefaultpresetbutton
        o->end();
      } // Fl_Group* o
      { Fl_Group* o = new Fl_Group(5, 25, 460, 260, "Jack");
        o->labelsize(12);
        o->hide();
        { Fl_Input* o = new Fl_Input(218, 149, 100, 22, "Jack Server");
          o->tooltip("Name of the jack server to connect to - default, ...");
          o->labelsize(12);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_Jack);
          o->insert(Runtime.jackServer.c_str());
        } // Fl_Input* o
        o->end();
      } // Fl_Group* o
      { Fl_Group* o = new Fl_Group(5, 25, 460, 260, "Alsa");
        o->labelsize(12);
        { Fl_Input* o = new Fl_Input(195, 54, 120, 22, "Alsa Midi Device");
          o->tooltip("Alsa midi device - default, hw:0, ...");
          o->labelsize(12);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_Alsa);
          o->insert(Runtime.alsaMidiDevice.c_str());
        } // Fl_Input* o
        { Fl_Input* o = new Fl_Input(195, 95, 120, 22, "Alsa Audio Device");
          o->tooltip("Alsa audio device - default, hw:0, front:CARD=Live,DEV=0, ...");
          o->labelsize(12);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_Alsa1);
          o->insert(Runtime.alsaAudioDevice.c_str());
        } // Fl_Input* o
        { Fl_Check_Browser* o = new Fl_Check_Browser(195, 133, 84, 50, "Samplerate");
          o->labelsize(12);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_Samplerate);
          o->align(Fl_Align(FL_ALIGN_LEFT));
          o->when(FL_WHEN_CHANGED);
          //
                o->add("96000");
                o->add("48000");
                o->add("44100");
                switch (Runtime.Samplerate)
                {
                    case 96000: o->set_checked(1); break;
                    case 44100: o->set_checked(3); break;
                    case 48000:
                    default: o->set_checked(2); break;
                }
        } // Fl_Check_Browser* o
        { Fl_Check_Browser* o = new Fl_Check_Browser(195, 197, 76, 73, "Period Size");
          o->labelsize(12);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_Period);
          o->align(Fl_Align(FL_ALIGN_LEFT));
          o->when(FL_WHEN_CHANGED);
          //
                o->add("64");
                o->add("128");
                o->add("256");
                o->add("512");
                o->add("1024");
                switch (Runtime.Buffersize)
                {
                    case 64: o->set_checked(1); break;
                    case 128: o->set_checked(2); break;
                    case 256: o->set_checked(3); break;
                    case 512: o->set_checked(4); break;
                    case 1024: o->set_checked(5); break;
                    default: o->set_checked(4); break;
                }
        } // Fl_Check_Browser* o
        o->end();
      } // Fl_Group* o
      o->end();
    } // Fl_Tabs* o
    { Fl_Button* o = new Fl_Button(238, 308, 105, 20, "Close");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Close);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(352, 308, 105, 20, "Save Settings");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Save);
    } // Fl_Button* o
    { Fl_Box* o = new Fl_Box(104, 285, 267, 17, "Most settings changes require a restart");
      o->labelfont(1);
      o->labelsize(11);
      o->labelcolor((Fl_Color)38);
      o->align(Fl_Align(FL_ALIGN_WRAP));
    } // Fl_Box* o
    configwindow->end();
  } // Fl_Double_Window* configwindow
  return configwindow;
}

ConfigUI::ConfigUI() {
  //
          configChanged = false;
          make_window();
          readbankcfg();
          readpresetcfg();
}

void ConfigUI::activatebutton_rootdir(bool active) {
  //
          if (active)
          {
              removerootdirbutton->activate();
              makedefaultrootdirbutton->activate();
          }
          else
          {
              removerootdirbutton->deactivate();
              makedefaultrootdirbutton->deactivate();
          }
}

void ConfigUI::activatebutton_presetdir(bool active) {
  //
          if (active)
          {
              removepresetbutton->activate();
              makedefaultpresetbutton->activate();
          }
          else
          {
              removepresetbutton->deactivate();
              makedefaultpresetbutton->deactivate();
          }
}

void ConfigUI::readbankcfg() {
  //
          rootsbrowse->clear();
          for (int i = 0; i < MAX_BANK_ROOT_DIRS; ++i)
          {
              if (Runtime.bankRootDirlist[i].size())
                  rootsbrowse->add(Runtime.bankRootDirlist[i].c_str());
          }
}

void ConfigUI::writebankcfg() {
  //
          Runtime.clearBankrootDirlist();
          for (int n = 0; n < rootsbrowse->size(); ++n)
              Runtime.bankRootDirlist[n] = string(rootsbrowse->text(n + 1));
}

void ConfigUI::readpresetcfg() {
  //
          presetbrowse->clear();
          for (int i = 0; i < MAX_BANK_ROOT_DIRS; ++i)
              if (Runtime.presetsDirlist[i].size())
                  presetbrowse->add(Runtime.presetsDirlist[i].c_str());
}

void ConfigUI::writepresetcfg() {
  //
          Runtime.clearPresetsDirlist();
          for (int n = 0; n < presetbrowse->size(); ++n)
              Runtime.presetsDirlist[n] = string(presetbrowse->text(n + 1));
}

void ConfigUI::Show() {
  configwindow->show();
}

void ConfigUI::Hide() {
  configwindow->hide();
}

void ConfigUI::savesettings(void) {
  //
          Runtime.saveConfig();
          writebankcfg();
          writepresetcfg();
}
