// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009-2011, Alan Calvert

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is derivative of ZynAddSubFX original code, modified March 2011

// generated by Fast Light User Interface Designer (fluid) version 1.0302

#ifndef ConfigUI_h
#define ConfigUI_h
#include <FL/Fl.H>
#include <cmath>
#include <FL/Fl_File_Chooser.H>
#include "Misc/Config.h"
#include "Misc/MiscFuncs.h"
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Tabs.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Browser.H>
#include <FL/Fl_Check_Browser.H>
#include <FL/Fl_Box.H>

class ConfigUI : private MiscFuncs {
public:
  Fl_Double_Window* make_window();
  Fl_Double_Window *configwindow;
private:
  inline void cb_configwindow_i(Fl_Double_Window*, void*);
  static void cb_configwindow(Fl_Double_Window*, void*);
  inline void cb_OscilSize_i(Fl_Choice*, void*);
  static void cb_OscilSize(Fl_Choice*, void*);
  static Fl_Menu_Item menu_OscilSize[];
  inline void cb_PADsynth_i(Fl_Choice*, void*);
  static void cb_PADsynth(Fl_Choice*, void*);
  static Fl_Menu_Item menu_PADsynth[];
  inline void cb_Virtual_i(Fl_Choice*, void*);
  static void cb_Virtual(Fl_Choice*, void*);
  static Fl_Menu_Item menu_Virtual[];
public:
  Fl_Input *SessionStateFile;
private:
  inline void cb_SessionStateFile_i(Fl_Input*, void*);
  static void cb_SessionStateFile(Fl_Input*, void*);
public:
  Fl_Button *StateFileButton;
private:
  inline void cb_StateFileButton_i(Fl_Button*, void*);
  static void cb_StateFileButton(Fl_Button*, void*);
public:
  Fl_Browser *rootsbrowse;
private:
  inline void cb_rootsbrowse_i(Fl_Browser*, void*);
  static void cb_rootsbrowse(Fl_Browser*, void*);
  inline void cb_Add_i(Fl_Button*, void*);
  static void cb_Add(Fl_Button*, void*);
public:
  Fl_Button *removerootdirbutton;
private:
  inline void cb_removerootdirbutton_i(Fl_Button*, void*);
  static void cb_removerootdirbutton(Fl_Button*, void*);
public:
  Fl_Button *makedefaultrootdirbutton;
private:
  inline void cb_makedefaultrootdirbutton_i(Fl_Button*, void*);
  static void cb_makedefaultrootdirbutton(Fl_Button*, void*);
public:
  Fl_Browser *presetbrowse;
private:
  inline void cb_presetbrowse_i(Fl_Browser*, void*);
  static void cb_presetbrowse(Fl_Browser*, void*);
  inline void cb_Add1_i(Fl_Button*, void*);
  static void cb_Add1(Fl_Button*, void*);
public:
  Fl_Button *removepresetbutton;
private:
  inline void cb_removepresetbutton_i(Fl_Button*, void*);
  static void cb_removepresetbutton(Fl_Button*, void*);
public:
  Fl_Button *makedefaultpresetbutton;
private:
  inline void cb_makedefaultpresetbutton_i(Fl_Button*, void*);
  static void cb_makedefaultpresetbutton(Fl_Button*, void*);
  inline void cb_Jack_i(Fl_Input*, void*);
  static void cb_Jack(Fl_Input*, void*);
  inline void cb_Alsa_i(Fl_Input*, void*);
  static void cb_Alsa(Fl_Input*, void*);
  inline void cb_Alsa1_i(Fl_Input*, void*);
  static void cb_Alsa1(Fl_Input*, void*);
  inline void cb_Samplerate_i(Fl_Check_Browser*, void*);
  static void cb_Samplerate(Fl_Check_Browser*, void*);
  inline void cb_Period_i(Fl_Check_Browser*, void*);
  static void cb_Period(Fl_Check_Browser*, void*);
  inline void cb_Close_i(Fl_Button*, void*);
  static void cb_Close(Fl_Button*, void*);
  inline void cb_Save_i(Fl_Button*, void*);
  static void cb_Save(Fl_Button*, void*);
public:
  ConfigUI();
  void activatebutton_rootdir(bool active);
  void activatebutton_presetdir(bool active);
  void readbankcfg();
  void writebankcfg();
  void readpresetcfg();
  void writepresetcfg();
  void Show();
  void Hide();
private:
  void savesettings(void);
  bool configChanged; 
};
#endif
