// generated by Fast Light User Interface Designer (fluid) version 1.0302

#include "/home/iurt/rpmbuild/BUILD/yoshimi-0.060.12/src/build/MasterMiscUI.h"
// MasterUI.cc
// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009-2011, Alan Calvert

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is a derivative of the ZynAddSubFX original, modified March 2011


VUMeter::VUMeter(int x,int y, int w, int h, const char *label):Fl_Box(x,y,w,h,label) {
  npart=-1;
}

void VUMeter::init(int part_) {
  // the "part_" parameters sets the part (if it is >=0), else it sets the master
          label(NULL);
          npart = part_;
          olddbl = 0.0;
          olddbr = 0.0;
          oldrmsdbl = 0.0;
          oldrmsdbr = 0.0;
}

void VUMeter::draw_master() {
  #define MIN_DB (-48)
          int ox = x();
          int oy = y();
          int lx = w();
          int ly = h();
          float dbl = synth->vuOutPeakL;
          float dbr = synth->vuOutPeakR;
          float rmsdbl = synth->vuRmsPeakL;
          float rmsdbr = synth->vuRmsPeakR;
          float maxdbl = synth->vuMaxOutPeakL;
          float maxdbr = synth->vuMaxOutPeakR;
  //        bool clipped = synth->vuClipped;
          dbl = rap2dB(dbl);
          dbr = rap2dB(dbr);
          rmsdbl = rap2dB(rmsdbl);
          rmsdbr = rap2dB(rmsdbr);
          maxdbl = rap2dB(maxdbl);
          maxdbr = rap2dB(maxdbr);
          
          dbl = (MIN_DB - dbl) / MIN_DB;
          if (dbl < 0.0)
              dbl = 0.0;
          else if (dbl > 1.0)
              dbl = 1.0;
          dbr = (MIN_DB - dbr) / MIN_DB;
          if (dbr < 0.0)
              dbr = 0.0;
          else if (dbr > 1.0)
              dbr = 1.0;
          dbl = dbl * 0.4 + olddbl * 0.6;
          dbr = dbr * 0.4 + olddbr * 0.6;
          olddbl = dbl;
          olddbr = dbr;
  #      define VULENX (lx-35)
  #      define VULENY (ly/2-3)
          dbl *= VULENX;
          dbr *= VULENX;
  
          int idbl = dbl;
          int idbr = dbr;
  
          // compute RMS - start
          rmsdbl = (MIN_DB - rmsdbl) / MIN_DB;
          if (rmsdbl < 0.0)
              rmsdbl = 0.0;
          else if (rmsdbl > 1.0)
              rmsdbl = 1.0;
          rmsdbr = (MIN_DB - rmsdbr) / MIN_DB;
          if (rmsdbr < 0.0)
              rmsdbr = 0.0;
          else if (rmsdbr > 1.0)
              rmsdbr = 1.0;
          rmsdbl = rmsdbl * 0.4 + oldrmsdbl * 0.6;
          rmsdbr = rmsdbr * 0.4 + oldrmsdbr * 0.6;
          oldrmsdbl = rmsdbl;
          oldrmsdbr = rmsdbr;
          rmsdbl *= VULENX;
          rmsdbr *= VULENX;
  
          int irmsdbl = rmsdbl;
          int irmsdbr = rmsdbr;
          // compute RMS - end
  
          // draw db level
          fl_rectf(ox, oy, idbl, VULENY, 0, 200, 255);
          fl_rectf(ox, oy + ly / 2, idbr, VULENY, 0, 200, 255);
  
          // fill with black
          fl_rectf(ox + idbl, oy, VULENX - idbl, VULENY, 0, 0, 0);
          fl_rectf(ox + idbr, oy + ly / 2, VULENX - idbr, VULENY, 0, 0, 0);
  
          // draw scale
          float tmp = VULENX * 1.0 / MIN_DB;
          for (int i = 1; i < 1 - MIN_DB; ++i)
          {
             int tx = VULENX + (int)(tmp * i);
             fl_rectf(ox + tx, oy, 1, VULENY + ly / 2, 0, 160, 200);
             if (i % 5 == 0)
                 fl_rectf(ox + tx, oy, 1, VULENY + ly / 2, 0, 230, 240);
             if (i % 10 == 0)
                 fl_rectf(ox + tx - 1, oy, 2, VULENY + ly / 2, 0, 225, 255);
          }
  
          // mellow yellow rms indicator
          if (irmsdbl > 2)
              fl_rectf(ox + irmsdbl - 1, oy, 3, VULENY, 255, 255, 0);
          if (irmsdbr > 2)
              fl_rectf(ox + irmsdbr - 1, oy + ly / 2, 3, VULENY, 255, 255, 0);
  
          // see red if clipped
          if (synth->vuClippedL)
              fl_rectf(ox + VULENX + 2, oy, lx - VULENX - 3, ly / 2 - 3, 250, 10, 10);
          else
              fl_rectf(ox + VULENX + 2, oy, lx - VULENX - 3, ly / 2 - 3, 0, 0, 10);
  
          if (synth->vuClippedR)
              fl_rectf(ox + VULENX + 2, oy + ly / 2, lx - VULENX - 3, (ly - 2) / 2 - 2, 250, 10, 10);
          else
              fl_rectf(ox + VULENX + 2, oy + ly / 2, lx - VULENX - 3, (ly - 2) / 2 - 2, 0, 0, 10);
  
          // show maxdB
          static char tmpstr[8];
          const char *dbtag = "dB";
          if ((maxdbl > MIN_DB - 20))
          {
              fl_font(FL_HELVETICA | FL_BOLD, 9);
              fl_color(255, 255, 255);
              //snprintf(tmpstr, 7, "%+3li%s", lrintf(maxdbl + 0.5f), dbtag);
              snprintf(tmpstr, 7, "%+3.f%s", maxdbl + 0.5f, dbtag);
              fl_draw(tmpstr, ox + VULENX + 1, oy + 1,
                      lx - VULENX - 4, VULENY - 2, FL_ALIGN_RIGHT, NULL, 0);
          }
          if ((maxdbr > MIN_DB - 20))
          {
              fl_font(FL_HELVETICA | FL_BOLD, 9);
              fl_color(255, 255, 255);
              //snprintf(tmpstr, 7, "%+3li%s", lrintf(maxdbr + 0.5f), dbtag);
              snprintf(tmpstr, 7, "%+3.f%s", maxdbr + 0.5f, dbtag);
              fl_draw(tmpstr, ox + VULENX + 1, oy + ly / 2 + 1,
                      lx - VULENX - 4, VULENY, FL_ALIGN_RIGHT, NULL, 0);
          }
}

void VUMeter::draw_part() {
  #define MIN_DB (-48)
          int ox = x();
          int oy = y();
          int lx = w();
          int ly = h();
          if (!active_r())
          {
              fl_rectf(ox, oy, lx, ly, 140, 140, 140);
              if (synth->fakepeakpart[npart] > 0)
              {
                  int fakedb = synth->fakepeakpart[npart] / 255.0 * ly + 4;
                  fl_rectf(ox + 2, oy + ly - fakedb, lx - 4, fakedb, 0, 0, 0);
              }
              return;
          }
          // draw the vu lines
          float db = synth->vuoutpeakpart[npart];
          db = rap2dB(db);
  
          db = (MIN_DB - db) / MIN_DB;
          db = (db > 1.0) ? 1.0 : db;
          db *= ly - 2;
          int idb = (int) db;
  
          fl_rectf(ox, oy + ly - idb, lx, idb, 0, 200, 255);
          fl_rectf(ox, oy, lx, ly - idb, 0, 0, 0);
  
          // draw the scales
          float tmp = ly * 1.0 / MIN_DB;
          for (int i = 1; i < 1 - MIN_DB; ++i)
          {
              int ty = ly + (int)(tmp * i);
              if ( i % 5 == 0)
                  fl_rectf(ox, oy + ly - ty, lx, 1, 0, 160, 200);
              if (i % 10 == 0)
                  fl_rectf(ox, oy + ly - ty, lx, 1, 0, 230, 240);
          }
}

void VUMeter::draw() {
  if (npart>=0) draw_part();
     else draw_master();
}

void VUMeter::tickdraw(VUMeter *o) {
  o->redraw();
}

void VUMeter::tick(void *v) {
  tickdraw((VUMeter *) v);
          Fl::add_timeout(0.033333333, tick, v); // 1.0 / 30.0 => 30 fps
}

int VUMeter::handle(int event) {
  switch(event){
              case FL_SHOW:
                  tick(this);
                  break;
              case FL_HIDE:
                  Fl::remove_timeout(tick, this);
                  break;
              case FL_PUSH:
                  if (npart < 0) //if (npart >= 0) break;
                      synth->vuresetpeaks();
                  break;
          }
          return 1;
}

SysEffSend::SysEffSend(int x,int y, int w, int h, const char *label):WidgetPDial(x,y,w,h,label) {
  neff1=0; neff2=0;
}

void SysEffSend::init(int neff1_,int neff2_) {
  neff1 = neff1_;
          neff2 = neff2_;
          minimum(0);
          maximum(127);
          step(1);
          labelfont(1);
          labelsize(10);
          align(FL_ALIGN_TOP);
          value(synth->Psysefxsend[neff1][neff2]);
          copy_label((asString(neff1 + 1) + "->" + asString(neff2 + 1)).c_str());
}

SysEffSend::~SysEffSend() {
  hide();
}

int SysEffSend::handle(int event) {
  if (event == FL_PUSH || event == FL_DRAG)
          {
              synth->setPsysefxsend(neff1,neff2,value());
          }
          return WidgetPDial::handle(event);
}

void Panellistitem::cb_partname_i(Fl_Button*, void*) {
  if ((int)bankui->cbwig->value() != (npart + 1))
              {
                  bankui->cbwig->value(npart+1);
                  bankui->cbwig->do_callback();
              }
              bankui->Show();
}
void Panellistitem::cb_partname(Fl_Button* o, void* v) {
  ((Panellistitem*)(o->parent()->parent()->user_data()))->cb_partname_i(o,v);
}

void Panellistitem::cb_partvolume_i(Fl_Slider* o, void*) {
  synth->part[npart]->setVolume(o->value());
}
void Panellistitem::cb_partvolume(Fl_Slider* o, void* v) {
  ((Panellistitem*)(o->parent()->parent()->user_data()))->cb_partvolume_i(o,v);
}

void Panellistitem::cb_partpanning_i(WidgetPDial* o, void*) {
  synth->part[npart]->SetController(C_panning, (char)o->value());
}
void Panellistitem::cb_partpanning(WidgetPDial* o, void* v) {
  ((Panellistitem*)(o->parent()->parent()->user_data()))->cb_partpanning_i(o,v);
}

void Panellistitem::cb_edit_i(Fl_Button*, void*) {
  if ((int)bankui->cbwig->value() != (npart + 1))
              {
                  bankui->cbwig->value(npart+1);
                  bankui->cbwig->do_callback();
              };
}
void Panellistitem::cb_edit(Fl_Button* o, void* v) {
  ((Panellistitem*)(o->parent()->parent()->user_data()))->cb_edit_i(o,v);
}

void Panellistitem::cb_partrcv_i(Fl_Choice* o, void*) {
  synth->part[npart]->Prcvchn=o->value();
}
void Panellistitem::cb_partrcv(Fl_Choice* o, void* v) {
  ((Panellistitem*)(o->parent()->parent()->user_data()))->cb_partrcv_i(o,v);
}

void Panellistitem::cb_partenabled_i(Fl_Check_Button* o, void*) {
  synth->actionLock(lockmute);
            synth->partonoff(npart, o->value());
            synth->actionLock(unlock);
            if (o->value() == 0)
                panellistitemgroup->deactivate();
            else
            {
                panellistitemgroup->activate();
                if ((int)bankui->cbwig->value() != (npart + 1))
                {
                    bankui->cbwig->value(npart + 1);
                    bankui->cbwig->do_callback();
                }
            }
            o->redraw();
}
void Panellistitem::cb_partenabled(Fl_Check_Button* o, void* v) {
  ((Panellistitem*)(o->parent()->user_data()))->cb_partenabled_i(o,v);
}

Fl_Group* Panellistitem::make_window() {
  { panellistitem = new Fl_Group(0, 0, 70, 260);
    panellistitem->box(FL_FLAT_BOX);
    panellistitem->color(FL_BACKGROUND_COLOR);
    panellistitem->selection_color(FL_BACKGROUND_COLOR);
    panellistitem->labeltype(FL_NO_LABEL);
    panellistitem->labelfont(0);
    panellistitem->labelsize(14);
    panellistitem->labelcolor(FL_FOREGROUND_COLOR);
    panellistitem->user_data((void*)(this));
    panellistitem->align(Fl_Align(FL_ALIGN_TOP));
    panellistitem->when(FL_WHEN_RELEASE);
    { Fl_Group* o = panellistitemgroup = new Fl_Group(0, 20, 70, 240);
      panellistitemgroup->box(FL_PLASTIC_THIN_UP_BOX);
      { Fl_Group* o = new Fl_Group(45, 65, 15, 110);
        o->box(FL_ENGRAVED_FRAME);
        { VUMeter* o = new VUMeter(45, 65, 15, 110, "V U");
          o->box(FL_FLAT_BOX);
          o->color(FL_FOREGROUND_COLOR);
          o->selection_color((Fl_Color)75);
          o->labeltype(FL_NORMAL_LABEL);
          o->labelfont(0);
          o->labelsize(14);
          o->labelcolor((Fl_Color)55);
          o->align(Fl_Align(FL_ALIGN_WRAP));
          o->when(FL_WHEN_RELEASE);
          o->init(npart);
        } // VUMeter* o
        o->end();
      } // Fl_Group* o
      { partname = new Fl_Button(5, 27, 60, 30, "  ");
        partname->box(FL_THIN_DOWN_BOX);
        partname->down_box(FL_FLAT_BOX);
        partname->labelfont(1);
        partname->labelsize(10);
        partname->callback((Fl_Callback*)cb_partname);
        partname->align(Fl_Align(192|FL_ALIGN_INSIDE));
      } // Fl_Button* partname
      { Fl_Slider* o = partvolume = new Fl_Slider(10, 65, 30, 110);
        partvolume->type(4);
        partvolume->box(FL_FLAT_BOX);
        partvolume->minimum(127);
        partvolume->maximum(0);
        partvolume->step(1);
        partvolume->value(127);
        partvolume->callback((Fl_Callback*)cb_partvolume);
        o->value(synth->part[npart]->Pvolume);
      } // Fl_Slider* partvolume
      { WidgetPDial* o = partpanning = new WidgetPDial(20, 180, 30, 30);
        partpanning->box(FL_OVAL_BOX);
        partpanning->color(FL_BACKGROUND_COLOR);
        partpanning->selection_color(FL_INACTIVE_COLOR);
        partpanning->labeltype(FL_NORMAL_LABEL);
        partpanning->labelfont(0);
        partpanning->labelsize(14);
        partpanning->labelcolor(FL_FOREGROUND_COLOR);
        partpanning->maximum(127);
        partpanning->step(1);
        partpanning->callback((Fl_Callback*)cb_partpanning);
        partpanning->align(Fl_Align(FL_ALIGN_BOTTOM));
        partpanning->when(FL_WHEN_CHANGED);
        o->value(synth->part[npart]->Ppanning);
      } // WidgetPDial* partpanning
      { Fl_Button* o = new Fl_Button(15, 235, 40, 20, "edit");
        o->box(FL_PLASTIC_UP_BOX);
        o->labelsize(10);
        o->callback((Fl_Callback*)cb_edit);
      } // Fl_Button* o
      { Fl_Choice* o = partrcv = new Fl_Choice(10, 213, 50, 15);
        partrcv->tooltip("receive from Midi channel");
        partrcv->down_box(FL_BORDER_BOX);
        partrcv->labelsize(10);
        partrcv->textfont(1);
        partrcv->textsize(10);
        partrcv->callback((Fl_Callback*)cb_partrcv);
        partrcv->align(Fl_Align(FL_ALIGN_TOP_LEFT));
        for(int i = 0; i < NUM_MIDI_CHANNELS; i++)
            {
                if (i != 9)
                    o->add(string("Ch" + asString(i + 1)).c_str());
                else
                    o->add("Dr10");
            }
        o->value(synth->part[npart]->Prcvchn);
      } // Fl_Choice* partrcv
      if (synth->part[npart]->Penabled==0) o->deactivate();
      panellistitemgroup->end();
    } // Fl_Group* panellistitemgroup
    { Fl_Check_Button* o = partenabled = new Fl_Check_Button(5, 0, 45, 20, "01");
      partenabled->down_box(FL_DOWN_BOX);
      partenabled->labeltype(FL_EMBOSSED_LABEL);
      partenabled->labelfont(1);
      partenabled->labelsize(13);
      partenabled->callback((Fl_Callback*)cb_partenabled);
      partenabled->align(Fl_Align(FL_ALIGN_RIGHT|FL_ALIGN_INSIDE));
      string tmp = asString(npart + 1);
            o->copy_label(tmp.c_str());
      o->value(synth->part[npart]->Penabled);
    } // Fl_Check_Button* partenabled
    panellistitem->end();
  } // Fl_Group* panellistitem
  return panellistitem;
}

Panellistitem::Panellistitem(int x,int y, int w, int h, const char *label):Fl_Group(x,y,w,h,label) {
  npart = 0;
          bankui = NULL;
}

void Panellistitem::init(int npart_, BankUI *bankui_) {
  npart=npart_;
          bankui = bankui_;
          make_window();
          panellistitem->show();
          end();
}

void Panellistitem::refresh() {
  partenabled->value(synth->part[npart]->Penabled);
          if (synth->part[npart]->Penabled != 0)
              panellistitemgroup->activate();
          else
              panellistitemgroup->deactivate();
          partvolume->value(synth->part[npart]->Pvolume);
          partpanning->value(synth->part[npart]->Ppanning);
          partrcv->value(synth->part[npart]->Prcvchn);
          partname->label(synth->part[npart]->Pname.c_str());
          if ((int)bankui->cbwig->value() != (npart + 1))
              panellistitemgroup->color(fl_rgb_color(160, 160, 160));
          else
              panellistitemgroup->color(fl_rgb_color(50,190,240));
          panellistitemgroup->redraw();
}

Panellistitem::~Panellistitem() {
  panellistitem->hide();
}
