// MasterUI.h
// generated by Fast Light User Interface Designer (fluid) version 1.0302

#ifndef MasterMiscUI_h
#define MasterMiscUI_h
#include <FL/Fl.H>
// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009-2011, Alan Calvert

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is a derivative of the ZynAddSubFX original, modified March 2011

#include <string>
using namespace std;
#include "ADnoteUI.h"
#include "SUBnoteUI.h"
#include "EffUI.h"
#include "VirKeyboardUI.h"
#include "ConfigUI.h"
#include "BankUI.h"
#include "PartUI.h"
#include "MicrotonalUI.h"
#include "PresetsUI.h"
#include "ParametersUI.h"
#include "ConsoleUI.h"
#include "Misc/SynthEngine.h"
#include "Misc/MiscFuncs.h"

class VUMeter : public Fl_Box, private MiscFuncs {
public:
  VUMeter(int x,int y, int w, int h, const char *label=0);
  void init(int part_);
  void draw_master();
  void draw_part();
  void draw();
  static void tickdraw(VUMeter *o);
  static void tick(void *v);
  int handle(int event);
private:
  int npart; 
  float olddbl; 
  float olddbr; 
  float oldrmsdbl; 
  float oldrmsdbr; 
};

class SysEffSend : public WidgetPDial, private MiscFuncs {
public:
  SysEffSend(int x,int y, int w, int h, const char *label=0);
  void init(int neff1_,int neff2_);
  ~SysEffSend();
  int handle(int event);
private:
  int neff1; 
  int neff2; 
};
#include <FL/Fl_Group.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Slider.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Check_Button.H>

class Panellistitem : public Fl_Group, private MiscFuncs {
  Fl_Group* make_window();
  Fl_Group *panellistitem;
  Fl_Group *panellistitemgroup;
public:
  Fl_Button *partname;
private:
  inline void cb_partname_i(Fl_Button*, void*);
  static void cb_partname(Fl_Button*, void*);
public:
  Fl_Slider *partvolume;
private:
  inline void cb_partvolume_i(Fl_Slider*, void*);
  static void cb_partvolume(Fl_Slider*, void*);
public:
  WidgetPDial *partpanning;
private:
  inline void cb_partpanning_i(WidgetPDial*, void*);
  static void cb_partpanning(WidgetPDial*, void*);
  inline void cb_edit_i(Fl_Button*, void*);
  static void cb_edit(Fl_Button*, void*);
public:
  Fl_Choice *partrcv;
private:
  inline void cb_partrcv_i(Fl_Choice*, void*);
  static void cb_partrcv(Fl_Choice*, void*);
  Fl_Check_Button *partenabled;
  inline void cb_partenabled_i(Fl_Check_Button*, void*);
  static void cb_partenabled(Fl_Check_Button*, void*);
public:
  Panellistitem(int x,int y, int w, int h, const char *label=0);
  void init(int npart_, BankUI *bankui_);
  void refresh();
  ~Panellistitem();
private:
  int npart; 
  BankUI *bankui; 
};
#endif
